# -*- coding: utf-8 -*-

#   This file is part of emesene.
#
#    Emesene is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    emesene is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with emesene; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#	Creator: Otávio Souza <leader@kinuxlinux.org>

import os
import CurrentSong

import dbus

class Amarok2(CurrentSong.CurrentSong):
    def __init__(self):
	CurrentSong.CurrentSong.__init__(self)
	if self.isRunning():
	    self.amarok = dbus.SessionBus().get_object('org.kde.amarok','/Player');
	    self.track = dbus.SessionBus().get_object('org.kde.amarok','/TrackList');

	self.check()
	
    def isRunning(self):
	if os.popen('ps -A | grep amarok').read() == "":
	    self.running = False
	else:
	    self.running = True
	
	return self.running
    
    def isPlaying(self):
	if self.isRunning():
	    return bool(self.amarok.PositionGet() > 0)
	else:
	    return False
    
    def getStatus(self):
	return (True , 'Ok')
    
    def check(self):
	if self.isPlaying():
	    self.info = self.track.GetMetadata(self.track.GetCurrentTrack());
	    self.artist = str(self.info['artist'])
	    self.album = str(self.info['album'])
	    self.title = str(self.info['title']);
	    return True
	else:
	    return False;
	
